#!/usr/bin/env python

from Numeric import *
from ve08ad import *

def test_elfnct(k,x,fx,gx,ndimk,ns,jflag,fmax,fnoise):
  temp = x[1] - x[2]
  fx[0] = sqrt(1+x[0]**2 + temp**2)
  fnoise[0] = 1e-15 * fx
  if jflag < 2: return
  gx[0] = x[0]/fx
  gx[1] = temp/fx
  gx[2] = -gx[1]
  gmax = max([abs(gx[0]),gx[1]])
  fnoise[0] = max([fnoise[0],1e-15*gmax]) 
  return

def test_range(k,mode,w1,w2,ndimk,nsubk,ns):
    nsubk[0] = 1
    if mode == 1:
       w2[0] = w1[0]
       w2[1] = w1[1] - w1[2]
    elif mode == 2:
       w2[0] = w1[0]
       w2[1] = 0.5*w1[1]
       w2[2] = -w1[1]
    elif mode == 3:
       w2[0] = w1[0]
       w2[1] = w1[1]
       w2[2] = -w1[1]
    elif mode == 4:
       w2[0] = w1[0]
       w2[1] = w1[1]
    return

def test_xlower(i):
    return -1e35

def test_xupper(i):
    return -1.0


n = 4
ns = 2
invar = zeros((n*ns,),Int32)
invar[:6] = asarray([1,2,3,2,3,4],Int32)
nvar = asarray([1,4,7],Int32)
lwk = asarray([47,0],Int32)
ngr = asarray([3000,0],Int32)
nit = asarray([1000,0],Int32)
epsil=1e-5
ebound=-1
fknown = 0
flowbd = 0
relpr = 1e-9
difgrd = 1e-5
restrt = 0
testgx = 1
hesdif = 0
stmax = 1e10
stepl = asarray([1e5,0],Int32)
istate = asarray([1,-1,-1,-1,1,1],Int32)
ipdevc = 6
ipfreq = 0
ipwhat = 1
wk = zeros((lwk[0],),Float64)
x = asarray([-3.5,0.1,0.3,-20.3],Float64)
fx = array((0,),Float64)

#print ve08ad.__doc__
iflag, info = ve08ad(n,ns,invar,nvar,test_elfnct,test_range,test_xlower,test_xupper,
         x,fx,epsil,ebound,ngr,nit,fknown,flowbd,relpr,difgrd,restrt,testgx,
         hesdif,stmax,stepl,istate,ipdevc,ipfreq,ipwhat,lwk,wk)

print iflag, info
print x
print fx

